<template>
  <div class="w-card" v-on="$listeners">
    <v-hover v-slot="{ hover }">
      <v-card :elevation="hover ? 12 : 2">
        <v-btn
          class="w-card__close"
          icon
          color="black"
          @click.stop="$emit('delete', item.id)"
        >
          <v-icon>mdi-close</v-icon>
        </v-btn>

        <v-list-item two-line>
          <v-list-item-content>
            <v-list-item-title class="text-h5" v-text="item.name" />
            <v-list-item-subtitle v-text="cardDate" />
          </v-list-item-content>
        </v-list-item>

        <v-card-text>
          <v-row align="center">
            <v-col class="text-h2" cols="6" v-html="temperature" />
            <v-col cols="3" v-html="temperatureMinMax" />
          </v-row>
        </v-card-text>

        <v-list>
          <v-list-item v-for="(prop, i) in customPropertiesList" :key="i">
            <v-list-item-title v-html="prop" />
          </v-list-item>

          <v-list-item
            v-for="{ icon, description, id } in item.weather"
            :key="id"
          >
            <v-list-item-title v-text="description" />

            <img :src="`https://openweathermap.org/img/wn/${icon}.png`" />
          </v-list-item>
        </v-list>
      </v-card>
    </v-hover>
  </div>
</template>

<script>
import messages from "@/locales/w-card";

export default {
  name: "WCard",
  i18n: {
    messages,
  },
  props: {
    item: {
      type: Object,
      default: () => ({}),
    },
  },
  computed: {
    customPropertiesList() {
      return [
        this.temperatureFeels,
        this.humidity,
        this.pressure,
        this.windSpeed,
        this.windDegrees,
        this.windGust,
        this.sunset,
        this.sunrise,
      ].filter((property) => Boolean(property));
    },

    cardDate() {
      const options = {
        year: "numeric",
        month: "long",
        day: "numeric",
        weekday: "long",
        hour: "numeric",
        minute: "numeric",
      };
      const date = new Date(this.item.dt * 1000);
      const { locale } = this.$i18n;
      return date.toLocaleString(locale, options);
    },

    temperature() {
      // REVIEW вставлять в строку html чтобы потом использовать v-html не хорошо, можно было просто в шаблоне
      return `${Number(this.item.main.temp).toFixed()}&deg;C`;
    },

    temperatureFeels() {
      return `${this.$t("temperatureFeelsLike")}: ${Number(
        this.item.main.feels_like
      ).toFixed()}&deg;C`;
    },

    pressure() {
      return `${this.$t("pressure")}: ${Number(
        this.item.main.pressure
      ).toFixed()} hPa`;
    },

    humidity() {
      return `${this.$t("humidity")}: ${Number(
        this.item.main.humidity
      ).toFixed()}%`;
    },

    temperatureMinMax() {
      // REVIEW <br/> в строке не лучшее решение
      return `${Number(this.item.main.temp_min).toFixed()}&deg;C
        <br/>
        ${Number(this.item.main.temp_max).toFixed()}&deg;C`;
    },

    windSpeed() {
      const isEmpty = !this.item.wind?.speed;

      if (isEmpty) {
        return "";
      }

      return `${this.$t("windSpeed")} ${this.item.wind.speed} ${this.$t(
        "meterPerSecond"
      )}`;
    },

    windDegrees() {
      const isEmpty = !this.item.wind?.deg;

      if (isEmpty) {
        return "";
      }

      return `${this.$t("windDirection")} ${this.item.wind.deg}&deg;`;
    },

    windGust() {
      const isEmpty = !this.item.wind?.gust;

      if (isEmpty) {
        return "";
      }

      return `${this.$t("windGusts")} ${this.item.wind.gust} ${this.$t(
        "meterPerSecond"
      )}`;
    },

    sunrise() {
      // REVIEW locale можно компьютедом 
      const { locale } = this.$i18n;
      return `${this.$t("sunrise")} ${new Date(
        this.item.sys.sunrise * 1000
      ).toLocaleTimeString(locale)}`;
    },

    sunset() {
      const { locale } = this.$i18n;
      return `${this.$t("sunset")} ${new Date(
        this.item.sys.sunset * 1000
      ).toLocaleTimeString(locale)}`;
    },
  },
};
</script>

// REVIEW scoped по хорошему надо для компонентов
<style lang="scss">
.w-card {
  $p: &;

  max-width: calc(100% / 4 - 24px);
  width: 100%;
  margin: 0 12px 12px 12px;
  cursor: pointer;
  position: relative;

  &__close {
    position: absolute;
    top: 4px;
    right: 4px;
    z-index: 5;
    opacity: 0;
    visibility: hidden;

    #{$p}:hover & {
      opacity: 1;
      visibility: visible;
    }
  }
}
</style>
